/* CS6 - Channel Services src/server.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

/*
cs = do_connect (list_ptr->vhost, pargv[1], cport, list_ptr->uname);

int do_connect (char *vhostname, char *hostname, u_short port, char *uname)
{
  int s;
  int f;
  struct hostent *he;
  struct sockaddr_in sin;

  f = 1;
  s = socket (AF_INET, SOCK_STREAM, 0);
  if (s < 0)
    return -2;
  memset (&sin, 0, sizeof (struct sockaddr_in));

  sin.sin_family = AF_INET;

  if (vhostname == NULL)
    f = 0;
  else if (strlen (vhostname) < 1)
    f = 0;

  sin.sin_addr.s_addr = (f ? inet_addr (vhostname) : INADDR_ANY);
  if ((sin.sin_addr.s_addr == -1) && f)
  {
    he = gethostbyname (vhostname);
    if (he)
    {
      memcpy (&sin.sin_addr, he->h_addr, he->h_length);
    }
    else
    {
      sin.sin_addr.s_addr = INADDR_ANY;
    }
  }

  if (bind (s, (struct sockaddr *) &sin, sizeof (struct sockaddr_in)) < 0)
  {
    return -9;
  }
  memset (&sin, 0, sizeof (struct sockaddr_in));

  sin.sin_family = AF_INET;
  sin.sin_port = htons (port);
  sin.sin_addr.s_addr = inet_addr (hostname);
  if (sin.sin_addr.s_addr == -1)
  {
    he = gethostbyname (hostname);
    if (!he)
      return -1;
    memcpy (&sin.sin_addr, he->h_addr, he->h_length);
  }
  if (jack->identwd)
  {
    FILE *fp = NULL;
    struct passwd *pw = getpwuid (getuid ());
    char filename[1024];

    sprintf (filename, "%s/.identwd/%s.%i.LOCK",
             pw->pw_dir, inet_ntoa (sin.sin_addr),
             port);
    fp = fopen (filename, "w");
    if (fp)
    {
      fprintf (fp, "WAIT\n");
      fclose (fp);
    }
  }

  if (connect (s, (struct sockaddr *) &sin, sizeof (sin)) < 0)
  {
    close (s);
    return -2;
  }
  if (jack->identwd)
  {
    FILE *fp = NULL;
    struct passwd *pw = getpwuid (getuid ());
    char filename[1024];

    sprintf (filename, "%s/.identwd/%s.%i.LOCK",
             pw->pw_dir, inet_ntoa (sin.sin_addr),
             port);
    fp = fopen (filename, "w");
    if (fp)
    {
      int len = sizeof (struct sockaddr_in);
      struct sockaddr_in mysa;

      getsockname (s, (struct sockaddr *) &mysa, &len);
      fprintf (fp, (char *) "%s %i %s\n",
               (char *) inet_ntoa (mysa.sin_addr),
               (u_short) ntohs (mysa.sin_port),
               uname);
      fclose (fp);
    }
  }
  return s;
}
*/
int get_connection(char *hostname, int port)
{
   struct sockaddr_in sa;
   struct hostent *hp;
   int sckfd;
   if((hp = gethostbyname(hostname)) == NULL) 
   {
      errno = ECONNREFUSED;
      return(-1);
   }
   bzero(&sa, sizeof(sa));
   bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);
   sa.sin_family = hp->h_addrtype;
   sa.sin_port = htons((u_short) port);
   if((sckfd = socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0) return(-1);
   setsockopt(sckfd, SOL_SOCKET, SO_LINGER, 0, 0);
   setsockopt(sckfd, SOL_SOCKET, SO_REUSEADDR, 0, 0);
   setsockopt(sckfd, SOL_SOCKET, SO_KEEPALIVE, 0, 0);
   if(connect(sckfd, (struct sockaddr *) &sa, sizeof(sa)) < 0) 
   {
      close(sckfd);
      return(-1);
   }
   return(sckfd);
}

int readln()
{
   char ch, *botnum = NULL;
   int i = 0;
   do 
   {
      if(read(socketfd, &ch, 1) < 1) return(0);
      if(ch >= 32 || ch <= 126)
	 if(i < MAXLEN - 1) line[i++] = ch;
   }    
   while(ch != '\n');
   line[i] = '\0';
   botnum=get_usernum(bot.nick);
   if(strstr(line, "PRIVMSG") && !strstr(line, botnum)) return 1;
   if(logging && !strstr(line, "AWAY"))
      log(BOT_LOG, "R [%s] %s",date(), line);
#ifdef DEBUG
   printf("Read - %s", line);
#endif
   return 1;
}

int read_from_socket(int sock, char *buffer)
{
   char ch;
   int i = 0;
   do 
   {
      if(read(sock, &ch, 1) < 1) return(0);
      if(ch >= 32 || ch <= 126)
	 if(i < MAXLEN - 1) buffer[i++] = ch;
   }    
   while(ch != '\n');
   buffer[i] = '\0';
#ifdef DEBUG
   printf("Read from socket - %s\n", buffer);
#endif
   return 1;
}

int writeln(char *buffer)
{
   if(write(socketfd, buffer, strlen(buffer)) < 0) return(0);
   if(logging)
      log(BOT_LOG, "W [%s] %s",date(), buffer);
#ifdef DEBUG
   printf("Write - %s\n", buffer);
#endif
}

int writeln2(int sock, char *buffer)
{
   if(write(sock, buffer, strlen(buffer)) < 0) return(0);
   return 1;
}

void sendping()
{
   send_to_server(":%s PING :%s\n", myserver, bot.server);
   bot.server_active = FALSE;
}

int send_to_socket(int sck, char *format, ...)
{
   va_list arglist;
   char buffer[MAXBUF];
   va_start(arglist, format);
   vsprintf(buffer, format, arglist);
   va_end(arglist);
   return(writeln2(sck, buffer));
}

void init_bot()
{
   int mypid = 0;
   FILE *out;

   did_eoback = FALSE;
   joined = FALSE;
   strcpy(bot.nick, botnick);
   send_to_server("PASS %s\n", netpass);
   send_to_server("SERVER %s %d 0 %ld P10 %cD] :[%s] %s\n", myserver, HOPCOUNT + 1, time(NULL),convert2y[server_num], myserver,  reason);
   serv_used(convert2y[server_num], myserver);

   mypid = getpid();
   if (out = fopen(pid_file, "wt"))
   {
      fprintf(out, "%i\n", mypid);
      fclose(out);
   }
}

void reinit()
{
   char *usernum = NULL;

   usernum=get_free_usernum(bot.nick);
   send_to_server(":%s WALLOPS :Re-initialising Operator Service\n", myserver);
   send_to_server("%c NICK %s 1 %lu %s %s DQx8MG %s :%s\n", convert2y[server_num], bot.nick, time(NULL), ircuser, myserver, usernum,ircname);
   add_nickinfo(bot.nick, ircuser, myserver, usernum, myserver, reason);
   send_to_server(":%s MODE %s %s\n", bot.nick, bot.nick, mymodes);
   join_msgchan();
   join_channels();
}

int reconnect()
{
   char *botnum;

   if(bot.server_active == FALSE) 
   {
      botnum=get_usernum(bot.nick);
      delete_usernum(botnum);
      write_all_files();
      free_hublist();
      free_nicklist();
      close(socketfd);
      return 0;
   }
   return 1;
}

void die(char *who, char *rest)
{
   char buff[300], *chan = 0;
   FILE *fp;
   int i = 0;

   buff[0] = '\0';
   if(ymsgchan)
      send_to_server(":%s PRIVMSG %s :Operator Services will now terminate.\n", bot.nick, msg_chan);
   send_to_server(":%s QUIT :%s\n", bot.nick, quit_msg);
   send_to_server(":%s SQUIT %s :Just keeps getting better and better !\n", myserver, myserver);
   write_all_files();
   exit(0);
}
